#!/usr/bin/perl -w

=head1 NAME

B<POWER::Feed> - 

=head1 SYNOPSIS

 use POWER::Feed @dirs;

 @feed = (
    { feed => "Web::www_av_com", query => "perl" },
    { feed => "SportBet::www_betandwin_com" },
    );
 @RESULT = Feed(\@feed, $timeout, $DEBUG);

=head1 DESCRIPTION

  :  User-agent, Referer,
 Cookies, ,  POST  .

  :     
      ,  
     . , 
  ,     .
         
 ,     .

       / 
.

/ :    ,
 /  ,     
 /.

=head1 FUNCTIONS

=over 4

=cut

package POWER::Feed;

use POWER::lib qw(time);
use POWER::Multi::GET 2.00;
use POWER::Tree::AnyValue;

use strict;
our ($VERSION, $ROOTPKG, %FEED, %DTD, $HandlerTimeout,   $t);
our ($DEBUG, @RESULT, %URL, $URL, $HTML, %Data, %Feed);	#  local  Feed()

$VERSION = "0.05";

sub import {
    no strict;
    *{"${\scalar caller}::$_"} = \&{$_} for qw(Feed);
    shift; load_feed($_,"") for @_, grep {-d} map {"$_/POWER/Feed/"} @INC;
}

$ROOTPKG	    = __PACKAGE__."::";
%FEED		    = ();
%DTD		    = ();
$HandlerTimeout	    = undef;

#    
$t	    = qr/[^>]*>\s*/;

=item B<>()

         
feeds      feed   .

    Add_Feed(), URL(), RESULT(), $t   
   .
    ,   
   .
-      POWER::lib.

      .

        feed,  
    ,      eval.

        \W   _ .

=cut

{ my %loaded_pkg;
sub load_feed {
    my ($dir, $pkg) = @_;
    opendir my $D, $dir or die $!; 
    for my $item (grep {m/^[^.]/} readdir $D) {
	my $path = $dir."/".$item;
	$item =~ s/\W/_/g;
	my $pkg  = $pkg.$item;
	if (-d $path) {
	    load_feed($path, $pkg."::");
	} elsif (-f $path and not $loaded_pkg{$pkg}++) {
	    no strict;
	    *{$ROOTPKG.$pkg."::".$_} = \&{$_} for qw(URL RESULT DEBUG_STRING Add_Feed);
	    ${$ROOTPKG.$pkg."::".$_} = ${$_}  for qw(t);
	    local $_ = Cat($path);
	    Regexp::Common::Fast::filter() if exists &Regexp::Common::Fast::filter;
	    eval "package $ROOTPKG$pkg; use POWER::lib;".$_;
	    die $@ if $@;
	}
    }
}}

=item B<>()

     Feed.

        feed   
feed, pkg, path, file, type, url.

=cut

sub Add_Feed {
    my ($pkg, $type, $url) = (scalar(caller), @_);
    $pkg =~ /^\Q$ROOTPKG\E(.*::)?([^:]+)$/;
    $FEED{$1.$2."/".$type} = {feed=>$1.$2."/".$type, pkg=>$pkg, path=>$1,
	file=>$2, type=>$type, url=>$url};
}

=item B<>()



=cut

{ my $ID;
sub URL {
    # TODO  ^~...~^  #~...~#  $_[0]    %Data
    my ($handler, $url, $post_data) = split " ", shift, 3;
    return unless $url;
  my $DIE; local $SIG{ALRM} = sub { $DIE=1 };
    my %Data = @_;
    ++$ID; $URL{$ID} = {
	url		=> abs_url($url, $URL->{_url}),
	add_to_header	=> "Referer: ".($URL->{_url} || $url)."\r\n",
	post_data	=> $post_data,
	cookie		=> $URL->{_cookie},
	downloaded	=> \&Feed_Downloaded,
	ID		=> $ID,
	Handler		=> $Feed{pkg}."::".$handler,
	Feed		=> {%Feed},
	Data		=> \%Data,
	};
    $URL{$ID}{DEBUG_node} = $DEBUG->add_value($URL->{DEBUG_node} || "/", undef);
  die "alarm\n" if $DIE;
    return $URL{$ID};
}}

=item B<>()



=cut

sub RESULT {
  my $DIE; local $SIG{ALRM} = sub { $DIE=1 };
    my @res = map { {%Feed, %$_} } $DTD{$Feed{type}}->(@_);
    $DEBUG->add_value($URL->{DEBUG_node}, ["RESULT", $_]) for @res;
    push @RESULT, @res;
  die "alarm\n" if $DIE;
}

=item B<>()



=cut

sub DEBUG_STRING {
  my $DIE; local $SIG{ALRM} = sub { $DIE=1 };
    $DEBUG->add_value($URL->{DEBUG_node}, ["STRING", "@_"]);
  die "alarm\n" if $DIE;
}

=item B<>()



=cut

sub Feed {
    my ($feed, $timeout) = @_;
    ($DEBUG,@RESULT,%URL,$URL,$HTML,%Data,%Feed) = POWER::Tree::AnyValue->root();
    for (@$feed) {
	# TODO  $FEED{$_->{feed}}{url}  url,  sub,   sub(%$_)
	URL($Feed{url}, %$_), next if %Feed = %{$FEED{$_->{feed}}||{}};
	$DEBUG->add_value("/", ["STRING","Bad feed: `$_->{feed}'"]);
    }
    POWER::Multi::GET::Download(%URL, undef, $timeout);
    $_[2] = $DEBUG if @_ > 2;
    return @RESULT;
}

sub Feed_Downloaded {
    $URL    = delete $URL{$_[0]->{ID}};
    $HTML   = $URL->{_content};
    %Data   = %{$URL->{Data}||{}};
    %Feed   = %{$URL->{Feed}||{}};
    @{$URL}{"_ok","_err"} = ("ERR","Handler not found") 
	if $URL->{_ok} eq "OK" and not exists &{$URL->{Handler}};
    DEBUG_URL($URL);
    eval {
	local $SIG{__DIE__} = "IGNORE";
	#  die   ,   URL(), RESULT() 
	# DEBUG_STRING()  die     - 
	# die    POWER::Tree,    
	#  ,  tree2list    
	local $SIG{ALRM} = sub { die "alarm\n" };
	alarm($HandlerTimeout) if $HandlerTimeout;
        no strict;
	#    ,   
	#   next/last/redo  {Handler}
	{ &{$URL->{Handler}} if $URL->{_ok} eq "OK"; }
	alarm(0);
    };
    @{$URL}{"_ok","_err"} = ("ERR","Handler timed out")
	if $URL->{_ok} eq "OK" and $@ =~ /alarm/;
    $DEBUG->value($URL->{DEBUG_node}, ["URL", {
	ID	    => $URL->{ID},
	url	    => $URL->{url},
	_ok	    => $URL->{_ok},
	_err	    => $URL->{_err},
	_redirect   => $URL->{_redirect},
	_size	    => length($URL->{_content}),
	Handler	    => map({local $_=$_;s/^\Q$ROOTPKG\E//;$_} $URL->{Handler}),
	Feed	    => {%Feed},
	}]);
}

=item B<>()



=cut

sub DEBUG_URL {
}

=back

=head1 VARIABLES

=over 4

=item B<>



=back

=head1 HISTORY

 0.05		   8 21:32:32 EEST 2003
	-   Regexp::Common::Fast,  -
	     ,     
	-    POWER::Feed   

 0.04		  27 09:19:06 EET 2003
	-    / :
	    die("alarm\n")    RESULT(),
	  URL()  DEBUG_STRING()

 0.03		  12 15:37:31 EET 2003
	-    /  
	  $POWER::Feed::HandlerTimeout = $seconds; # 0 = disable
	-      next/last/redo
	     

 0.02		   7 23:06:28 EET 2002
	-  RESULT()    

 0.01		  16 16:55:41 EEST 2002
	- initial release

=head1 AUTHOR

Alex Efros <powerman@asdfGroup.com>
Nikita Savin <nikita@asdfGroup.com>

=cut

1;
